process.env.MODE = process.env.MODE || 'info'; //other: debug
process.env.NODE_ENV = process.env.NODE_ENV || 'dev';//Others: live or lab

var configure = {};
configure.appenders = { out: { type: "stdout", layout: { type: 'pattern', pattern: '[%p] [%d{ISO8601}Z] : %m' } } };
configure.pm2 = true;
configure.categories = { default: { appenders: ["out"], level: process.env.MODE } };

const log4js = require('log4js');
log4js.configure(configure);
global.logger = log4js.getLogger();

//Handle all error
process.on('uncaughtException', (err) => {
    logger.info('[CAUGHT EXCEPTION]',   + err.stack);
});

global.__ = __dirname;
global.log = logger;
global.moment = require('moment');
global.async = require("async");
global.CONF = require(__ + "/config/main")[process.env.NODE_ENV];
global.Util = require(__ + "/modules/Util");
global.Cache = require(__ + '/modules/Cache');

logger.info("[Environment] " + process.env.NODE_ENV)
logger.info("[MODE] " + process.env.MODE )

Cache.clearAll((err, result)=>{
    if(err) logger.error(err)

    logger.info("[Clear All Cache]");
    process.exit();
})