process.env.MODE = process.env.MODE || 'info'; //other: debug
process.env.NODE_ENV = process.env.NODE_ENV || 'dev';//Others: live or lab

var configure = {};
configure.appenders = { out: { type: "stdout", layout: { type: 'pattern', pattern: '[%p] [%d{yyyy/MM/dd hh:mm:ss}] : %m' } } };
configure.pm2 = true;
configure.categories = { default: { appenders: ["out"], level: process.env.MODE } };

const log4js = require('log4js');
const log4js_extend = require("log4js-extend"); 
log4js.configure(configure);
log4js_extend(log4js, { path: __dirname, format: " (./@file:@line)"});
global.logger = log4js.getLogger();

//Handle all error
process.on('uncaughtException', (err) => {
    logger.info('[CAUGHT EXCEPTION]',  err.stack);
});

global.__ = __dirname;
global.log = logger;
global.moment = require('moment');
global.async = require("async");
global.CONF = require(__ + "/config/main")[process.env.NODE_ENV];
global.Util = require(__ + "/modules/Util");
global.Cache = require(__ + '/modules/Cache');
global.Radius = require(__ + '/models/Radius');

logger.info("[Environment] " + process.env.NODE_ENV)
logger.info("[MODE] " + process.env.MODE )