const Schema = mongoose.Schema

var TrustMacSchema = new Schema({
    _id: {type: String, trim: true, required: true},
    name: {type: String, trim: true, required: true},
    keyword: { type: String, trim: true},
    mac_device: {type: Array},
    status: { type: String, enum: ['Active', 'Inactive'], required: true },
    session: {type: Number, default:60},
    idle: {type: Number, default:60},
	bwup: {type: Number, default: 1000000000},
    bwdown: {type: Number, default: 1000000000},
    createdAt: { type: String, trim: true, default: Util.now() },
    updatedAt: { type: String, trim: true, default: Util.now() },
    duration: { type: Number, trim: true },
    expired: { type: String, trim: true }
},{ versionKey: false })

TrustMacSchema.methods.generateId = () => Util.randomId();

module.exports = TrustMacSchema
