const crypto = require("crypto");

module.exports = {
    now: (format = "YYYY-MM-DD HH:mm:ss") => { return moment().utcOffset(420).format(format).toString() },
    genSalt: () => bcrypt.genSaltSync(10),
    hashPassword: (key, salt) => bcrypt.hashSync(key, salt),
    randomId: () => crypto.randomBytes(16).toString("hex"),
    hashKey: (key) => crypto.createHash('md5').update(key).digest("hex"),
    genToken: (user) => {
        var expiry = new Date();
        expiry.setDate(expiry.getDate() + 7);
        user.exp = parseInt(expiry.getTime() / 1000);
        return jwt.sign(user, "swifi");
    },
    decryptToken: (token) => { return jwt.decode(token); },
    isPasswordCorrect: (plainPassword, hashPassword) => { return bcrypt.compareSync(plainPassword, hashPassword) },
    isPhone: (phone) => {
        // MobiFone: 070|079|077|076|078|089|090|093
        // Vinaphone:083|084|085|081|082|088|091|094
        // Viettel:032|033|034|035|036|037|038|039|086|096|097|098
        // Vietnamobile:052|056|058|092
        // Gmobile:059|099
        var pattern = /^(070|079|077|076|078|089|090|093|083|084|085|081|082|088|091|094|032|033|034|035|036|037|038|039|086|096|097|098|052|056|058|092|059|099)\d{7}$/
        if (pattern.test(phone)) {
            return true;
        } else {
            return false;
        }
    },
    isString: (str) => {
        return typeof str == 'string' && str
    },
    isNumber: (num) => {
        isNaN(num)
    },
    isBoolean: (boo) => {
        return typeof boo == 'boolean'
    },
    isObject: (obj) => {
        return typeof obj == 'object' && obj && Object.keys(obj).length
    },
    isArray: (arr) => {
        return Array.isArray(arr) && arr.length
    },
    isMAC: (str) => {
        let re = /^([0-9A-F]{2}[:-]){5}([0-9A-F]{2})$/i
        return re.test(str);
    },
    isMACNoDelimiter: (str) => {
        let re = /^[0-9A-F]{12}$/i
        return re.test(str);
    },
    isEmail: (v) => {
        return /^([\w.%+-]+)@([\w-]+\.)+([\w]{2,})$/i.test(v);
    },
    getDomain: (email) => {
        return email.split('@')[1];
    },
    classify: (verify, data) => {
        let bad = {}
        let good = {}
        if (!Util.isObject(verify)) return { bad: ['Verify not object'], good: good }
        for (let i in verify) {
            if (Util.isObject(verify[i])) {
                switch (verify[i].type) {
                    case String:
                        if (Util.isString(data[i])) {
                            if (i == 'email' && !Util.isEmail(data[i])) bad[i] = 'is required email'
                            else if (i == 'phone' && !Util.isPhone(data[i])) bad[i] = 'is required phone'
                            else if (verify[i].required == true && !data[i]) bad[i] = 'is required'
                            else good[i] = String(data[i])
                        }
                        else if (verify[i].required == true) bad[i] = 'is required string'
                        break
                    case Number:
                        if (Util.isNumber(data[i])) good[i] = data[i]
                        else if (verify[i].required == true) bad[i] = 'is required number'
                        break
                    case Boolean:
                        if (Util.isBoolean(data[i])) good[i] = data[i]
                        else if (verify[i].required == true) bad[i] = 'is required boolean'
                        break
                    case Array:
                        if (Util.isArray(data[i])) good[i] = data[i]
                        else if (verify[i].required == true) bad[i] = 'is required array'
                        break
                    case Object:
                        if (Util.isObject(data[i])) good[i] = data[i]
                        else if (verify[i].required == true) bad[i] = 'is required object'
                        break
                }
            }
        }
        return { bad, good }
    },
}